<?php
/**
 * Tuto sur les opérations de chaine de caractères
 * 
 * @author      Jérémi Nihart <contact@endmove.eu>
 * @copyright   © 2021 EndMove, Tous droits réservés.
 * @link        https://www.endmove.eu/
 * 
 * @version     1.0
 */

$a = 5; $b = 3; 

//=============================================
echo "<h2>Négation</h2>";
# >----< Opérateur mathématique de négation (-$) >----<
# -$a => (5 * -1) => -5
# -$b => (3 * -1) => -3
echo -$a  .'<br>';  # La négation de $a ou $a vaut 5 sera (5 * -1) = -5
echo -$b  .'<br>';   # La négation de $b ou $b vaut 3 sera (3 * -1) = -3

//=============================================
echo "<h2>Addition</h2>";
# >----< Opérateur mathématique d'addition (+) >----<
# $a + $b => (5 + 3) => 8
echo $a + $b  .'<br>';  # L'addition de $a et $b ou $a vaut 5 et $b vaut 3 sera (5 + 3) = 8

//=============================================
echo "<h2>Soustraction</h2>";
# >----< Opérateur mathématique de soustraction (-) >----<
# $a - $b => (5 - 3) => 2
echo $a - $b  .'<br>';  # La soustraction de $a et $b ou $a vaut 5 et $b vaut 3 sera (5 - 3) = 2

//=============================================
echo "<h2>Multiplication</h2>";
# >----< Opérateur mathématique de multiplication (*) >----<
# $a * $b => (5 * 3) => 15
echo $a * $b  .'<br>';  # La multiplication de $a et $b ou $a vaut 5 et $b vaut 3 sera (5 * 3) = 15

//=============================================
echo "<h2>Division</h2>";
# >----< Opérateur mathématique de division (/) >----<
# $a / $b => (5 / 3) => 1.666666666666667
echo $a / $b  .'<br>';  # La division de $a et $b ou $a vaut 5 et $b vaut 3 sera (5 / 3) = 1.666666666666667


//=============================================
echo "<h2>Exposent</h2>";
# >----< Opérateur mathématique d'exponentiation (^) >----<
# $a ** $b => (5 ^ 3) => (5 * 5 * 5) => 125
echo $a ** $b  .'<br>';  # L'exponentiation de $a et $b ou $a vaut 5 et $b vaut 3 sera (5 ^ 3) = (5 * 5 * 5) = 125

//=============================================
echo "<h2>Modulo</h2>";
# >----< Opérateur mathématique de Modulus >----<
# <!> En réalité le modulo est une division entière on la représente par pourcentage " % " <!>
# Cela permet en outre de vérifier qu'un nombre est divisible par un autre, ...
# Par exemple si [ (x modulo 3) == 0 ] alors x est divisible par tois.
#                       |--> autre écriture : [ (x % 3) == 0 ]
# 
# $a % $b => (5 % 3) => 2 (dans 5 on a 1x3 reste 2)
# $b % $a => (3 % 5) => 3 (dans 3 on a 0x5 reste 3)
echo $a % $b  .'<br>';  # Le modulo de $a et $b ou $a vaut 5 et $b vaut 3 sera 2
echo $b % $a  .'<br>';  # Le modulo de $b et $a ou $b vaut 3 et $a vaut 5 sera 3

# Autre exemple : 17 % 5 => 2 (car dans 17 on à 3x5 (15) reste 2)
# On peut calculer le modulo autrement en fesant une division une multiplication suivi d'une soustraction :
# Résolution de 17 % 5 :
# 
#    On fait 17 / 5 = 3.4 (on voit donc que 5 rentre 3,4 fois dans 17) 
#                      <!> Pour continuer le calcul nous alons uniquement garder le nombre devant la virgule donc 3 <!>
#    On fais 5 * 3 = 15   (on voit donc que 5 rentré 3 fois de manière entière dans 17 vaut 15)
#    On fait alors 17 - 15 = 2 (on voit donc que le modulo est 2 car les 3 fois entière ou 5 rentre dans 17 donc 15 moins 17 vaut 2)
# 
# Voila nous venons de voir le fonctionnement du modulo !