<?php
/**
 * Tuto sur les opérations de chaine de caractères
 * 
 * @author      Jérémi Nihart <contact@endmove.eu>
 * @copyright   © 2021 EndMove, Tous droits réservés.
 * @link        https://www.endmove.eu/
 * 
 * @version     1.0
 */

# les doubles guillemets ( "" ) exécutent les variables qu'elles contiennent, pas les simples ( '' ).

# Définition d'une variable string contenant du texte.
$str = "Un texte quelconque...<br>";  # le <br> permet d'effectuer un retour à la ligne en HTML5.

# echo() est un fonction affichant le texte.
echo $str;  # alternative similaire: [echo "$str";] et [echo($str);].

# Une chaine de caractère est en réalité un tableau de caractères (une lettre est un caractère par exemple)
# on peut donc récupérer la xième lettre d'un mot de notre phrase. Sans oublier que dans un tableau l'index
# commence toujours à 0. Si je veux le 'x' de 'texte' je vais donc récupérer le 5ème élément du tableau $str
# aussi plus courrament appellé mon string.
echo $str[5];  # retourn le 5ème élément donc => 'x'.
echo '<br>';  # effectuer un retour à la ligne 

# concatèner deux chaines, pour contacténer (additionner) en php on utilise l'opérateur " . "
$str1 = 'Première partie';
$str2 = 'Deuxième partie';

$str = $str1 . ' & ' . $str2;  # Assignation de la valeur de la concaténation de 'str1' avec ' & ' et 'str2'
                               # dont la valeur est 'Première partie & Deuxième partie'.

# Dans l'exemple du dessus il n'y a pas de retour à la ligne, j'aimerais en ajouter un à la fin voici plusieurs
# méthode pour effectuer cette action. (note je vais stocker les méthode déconseilé dans une variable poubelle).

$poubelle = "$str<br>";         # Mauvaise pratique.
$poubelle = "$str" . "<br>";    # Mauvaise pratique.
$poubelle = $str . '<br>';      # Bonne pratique (dans certain cas son utilisation est inévitable).

$str .= '<br>';                 # Très bonne pratique.
echo $str;  # Affichage résultat
# ----> Comme on peut le voir l'opérateur ' .= ' permet de concaténer une variable directement avec celle
# qui contiendra le résultat.

# Quelques fonctions utilitaires 

# Mettre une chaine de caractère en majuscule avec strtoupper()
echo "<h2>function : strtoupper()</h2>";
echo strtoupper($str);  # Affiche la valeur de retour de strtoupper.

# Mettre une chaine de caractère en minuscule avec strtolower()
echo "<h2>function : strtolower()</h2>";
echo ($str = strtolower($str));  # Stock dans '$str' la valeur de retour de strtolower et l'affiche.

# Mettre la première lettre en majuscule avec ucfirst()
echo "<h2>function : ucfirst()</h2>";
echo ucfirst($str);

# Mettre la première lettre de chaque mot en majuscule avec ucwords()
echo "<h2>function : ucwords()</h2>";
echo ucwords($str);

# Compter le nombre de caractère d'un string
echo "<h2>function : strlen()</h2>";
echo strlen($str);

# Extraire un segment de la chaine de caractère en php (VOIR DOC PHP <!> pour plus d'infos)
echo "<h2>function : substr()</h2>";
echo substr($str, 10, 6);  # Récupère une sous chaine commencant au 10eme caractère et s'arretant 6 caractère plus loin.
# ----> substr(chaine, index de début (commence à 0), nombre de caractère (taille))
# <!> un accent est compté comme deux caractères !

# Récupérer la position de la première occurence d'un mot dans une chaine de caractère en php
echo "<h2>function : strpos()</h2>";
echo strpos($str, 'partie', -10);  # Récupère l'index de la première lettre du deuxième 'partie' présent dans la phrase $str en commensant 10 caractère avant la fin du string.
# ----> strpos(chaine, élément à chercher, index de début de la recherche (par défaut 0))
# <!> si l'index est négatif la recherche commence par la fin de la chaine <!>