<?php
/**
 * Tuto sur les variables et quelques opérations basiques
 * 
 * @author      Jérémi Nihart <contact@endmove.eu>
 * @copyright   © 2021 EndMove, Tous droits réservés.
 * @link        https://www.endmove.eu/
 * 
 * @version     1.1
 */

# 01 - Une variable nommé 'aNotDefinedVar', non définie (<!> != NULL) sans type.
$aNotDefinedVar;

# 02 - Une variable nommé 'anEmptyVar', vide (NULL) de type null. (note: en php, contrairement aux autres languages une variable null est un type de variable)
$anEmptyVar = NULL;

# 03 - Une variable nommé 'aString', contenant 'Je suis' de type string.
$aString = 'Je suis'; 

# 04 - Une variable nommé 'anInteger', de valeur 21 de type integer (int).
$anInteger = 21;

# 05 - Une variable nommé 'aDouble', de valeur 21.58 de type double (float).
$aDouble = 21.58;

# 06 - une variable nommé 'aBoolean', de valeur false de type boolean (bool).
$aBoolean = false;  # true||false

# 07 - Un tableau nommé 'anArray', de type array (tableau) qui contien:
# index  |  valeur  |  type
#--------+----------+---------
#     0  |   'aze'  |   string
#     1  |      45  |  integer
#     2  |    true  |  boolean
#     3  |    "wo"  |   string
#     4  |   false  |  boolean
#     5  | 62.0065  |   double
$anArray = array('aze', 45, true, "wo", false, 62.0065);

# On peut détruire une variable et donc arrivé à un cas égale à celui de l'exemple 01
# en utilisant la fonction unset();
$toUnset = "Du texte ...";  # Une variable nommé 'toUnset', de type string.
unset($toUnset);  # Destruction de la variable 'toUnset' => elle n'existe plus.

?>



<!-- FIN DU FICHIER DE COURS VOIR NAVIGATEUR
     Débugage des variables définie plus haut
     Visualiser le rendu dans un navigateur   -->
<h1>Fichier: Variables.php</h1>
<p>Il est interessant de débugger nos variables avec la fonction de
débuggage <code>var_dump()</code> celle-ci permet d'avoir un visuel sur
son contenu et son type. De plus il existe la fonction <code>gettype()</code>
qui permet de récupérer le type de variable qui lui est passé en argument 
(voir la documentation php).</p>
<hr>

<h2>Variable n°01</h2>
<p>ps: il est normal qu'une variable non initialisée Throw un erreur
en effet elle n'existe tout simplement pas ! Aucun espace mémoire réservé.</p>
<pre><?php var_dump($aNotDefinedVar); ?></pre>
<?= 'Type: '.gettype($aNotDefinedVar); ?>
<hr>

<h2>Variable n°02</h2>
<pre>var_dump: <?php var_dump($anEmptyVar); ?></pre>
<?= 'Type: '.gettype($anEmptyVar); ?>
<hr>

<h2>Variable n°03</h2>
<pre>var_dump: <?php var_dump($aString); ?></pre>
<?= 'Type: '.gettype($aString); ?>
<hr>

<h2>Variable n°04</h2>
<pre>var_dump: <?php var_dump($anInteger); ?></pre>
<?= 'Type: '.gettype($anInteger); ?>
<hr>

<h2>Variable n°05</h2>
<pre>var_dump: <?php var_dump($aDouble); ?></pre>
<?= 'Type: '.gettype($aDouble); ?>
<hr>

<h2>Variable n°06</h2>
<pre>var_dump: <?php var_dump($aBoolean); ?></pre>
<?= 'Type: '.gettype($aBoolean); ?>
<hr>

<h2>Variable n°07</h2>
<pre>var_dump: <?php var_dump($anArray); ?></pre>
<?= 'Type: '.gettype($anArray); ?>